#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from xpdeint.Segments.Integrators._FixedStepWithCross import _FixedStepWithCross

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 1)
__CHEETAH_genTime__ = 1426321582.242763
__CHEETAH_genTimestamp__ = 'Sat Mar 14 08:26:22 2015'
__CHEETAH_src__ = '/usr/src/RPM/BUILD/xmds2-2.2.2/xpdeint/Segments/Integrators/FixedStepWithCross.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Mar 14 07:54:55 2015'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class FixedStepWithCross(_FixedStepWithCross):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(FixedStepWithCross, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def leftRightDeltaAFunctionBody(self, function, replacementOperatorContainer, **KWS):



        ## CHEETAH: generated from @def leftRightDeltaAFunctionBody($function, $replacementOperatorContainer) at line 24, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        #  First evaluate any computed vector that any of our operators may depend on
        _v = VFFSL(SL,"evaluateComputedVectors",False)(VFFSL(SL,"dynamicVectorsNeedingPrecalculationForOperatorContainers",False)(VFFSL(SL,"intraStepOperatorContainers",True)), static = False) # u'${evaluateComputedVectors($dynamicVectorsNeedingPrecalculationForOperatorContainers($intraStepOperatorContainers), static = False)}' on line 27, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${evaluateComputedVectors($dynamicVectorsNeedingPrecalculationForOperatorContainers($intraStepOperatorContainers), static = False)}')) # from line 27, col 1.
        # 
        #  Then loop over operators that come before the delta A operators in the order in which
        #  they appear in the xmds script.
        # 
        for operatorContainer in VFFSL(SL,"intraStepOperatorContainers",True): # generated from line 32, col 3
            write(u'''
''')
            _v = VFN(VFFSL(SL,"operatorContainer",True),"evaluatePreDeltaAOperators",False)(parentFunction = function) # u'${operatorContainer.evaluatePreDeltaAOperators(parentFunction = function)}' on line 34, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'${operatorContainer.evaluatePreDeltaAOperators(parentFunction = function)}')) # from line 34, col 1.
        # 
        #  Now loop over delta A operators
        #  See the comment in _Integrator about why this needs to be done in
        #  this particular order
        for operatorContainer in VFFSL(SL,"intraStepOperatorContainersInFieldDescendingOrder",True): # generated from line 40, col 3
            #  Blank line for formatting
            write(u'''
''')
            if not operatorContainer == VFFSL(SL,"operatorContainerToOverride",True): # generated from line 43, col 5
                _v = VFN(VFFSL(SL,"operatorContainer",True),"evaluateDeltaAOperator",False)(parentFunction = function) # u'${operatorContainer.evaluateDeltaAOperator(parentFunction = function)}' on line 44, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'${operatorContainer.evaluateDeltaAOperator(parentFunction = function)}')) # from line 44, col 1.
            else: # generated from line 45, col 5
                _v = VFN(VFFSL(SL,"replacementOperatorContainer",True),"evaluateDeltaAOperator",False)(parentFunction = function) # u'${replacementOperatorContainer.evaluateDeltaAOperator(parentFunction = function)}' on line 46, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'${replacementOperatorContainer.evaluateDeltaAOperator(parentFunction = function)}')) # from line 46, col 1.
        # 
        #  Lastly, loop over the operators that come after the delta a operators in the order in
        #  which they appear in the xmds script.
        # 
        for operatorContainer in VFFSL(SL,"intraStepOperatorContainers",True): # generated from line 53, col 3
            #  Blank line for formatting
            write(u'''
''')
            _v = VFN(VFFSL(SL,"operatorContainer",True),"evaluatePostDeltaAOperators",False)(parentFunction = function) # u'${operatorContainer.evaluatePostDeltaAOperators(parentFunction = function)}' on line 56, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'${operatorContainer.evaluatePostDeltaAOperators(parentFunction = function)}')) # from line 56, col 1.
        # 
        write(u'''
''')
        integrationVectorsNeedingUpdating = VFFSL(SL,"integrationVectors",True)
        integrationVectorsNeedingUpdating.difference_update(replacementOperatorContainer.deltaAOperator.integrationVectors)
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectorsNeedingUpdating",True), VFFSL(SL,"homeBasis",True)) # u'${transformVectorsToBasis($integrationVectorsNeedingUpdating, $homeBasis), autoIndent=True}' on line 62, col 1
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u'${transformVectorsToBasis($integrationVectorsNeedingUpdating, $homeBasis), autoIndent=True}')) # from line 62, col 1.
        write(u'''
''')
        _v = VFFSL(SL,"loopOverVectorsWithInnerContentTemplate",False)(VFFSL(SL,"integrationVectorsNeedingUpdating",True),
''.join([u'// a = oldcopy + a\n_\\${vector.id}[\\$index] += _',str(VFFSL(SL,"name",True)),u'_oldcopy_\\${vector.id}[\\$index];\n']), basis = VFFSL(SL,"homeBasis",True))
        if _v is not None: write(_filter(_v, rawExpr=u'${loopOverVectorsWithInnerContentTemplate($integrationVectorsNeedingUpdating,\nc"""// a = oldcopy + a\n_\\${vector.id}[\\$index] += _${name}_oldcopy_\\${vector.id}[\\$index];\n""", basis = $homeBasis)}')) # from line 64, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        # FixedStepWithCross.tmpl
        # 
        # Created by Graham Dennis on 2008-11-12.
        # 
        # Copyright (c) 2008-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write(u'''

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_FixedStepWithCross= 'writeBody'

## END CLASS DEFINITION

if not hasattr(FixedStepWithCross, '_initCheetahAttributes'):
    templateAPIClass = getattr(FixedStepWithCross, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(FixedStepWithCross)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=FixedStepWithCross()).run()


