#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from xpdeint.Segments.Integrators._Stepper import _Stepper

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 1)
__CHEETAH_genTime__ = 1426321583.080764
__CHEETAH_genTimestamp__ = 'Sat Mar 14 08:26:23 2015'
__CHEETAH_src__ = '/usr/src/RPM/BUILD/xmds2-2.2.2/xpdeint/Segments/Integrators/SIStepper.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Mar 14 07:54:55 2015'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class SIStepper(_Stepper):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(SIStepper, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def name(self, **KWS):



        ## Generated from @def name: SI at line 24, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''SI''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def singleIntegrationStep(self, function, **KWS):



        ## CHEETAH: generated from @def singleIntegrationStep($function) at line 33, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        arguments = {'_step': '_step', VFFSL(SL,"propagationDimension",True): VFFSL(SL,"propagationDimension",True)}
        _v = VFFSL(SL,"callFunction",False)('nonconstantIPFields', arguments, _exponent = 1, parentFunction=function) # u"${callFunction('nonconstantIPFields', arguments, _exponent = 1, parentFunction=function)}" on line 36, col 1
        if _v is not None: write(_filter(_v, rawExpr=u"${callFunction('nonconstantIPFields', arguments, _exponent = 1, parentFunction=function)}")) # from line 36, col 1.
        write(u'''

''')
        _v = VFFSL(SL,"callFunction",False)('ipEvolve', arguments, _exponent = +1, parentFunction=function) # u"${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction=function)}" on line 38, col 1
        if _v is not None: write(_filter(_v, rawExpr=u"${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction=function)}")) # from line 38, col 1.
        write(u'''

''')
        _v = VFFSL(SL,"propagationDimension",True) # u'${propagationDimension}' on line 40, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${propagationDimension}')) # from line 40, col 1.
        write(u''' += 0.5*_step;

''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # u'${transformVectorsToBasis($integrationVectors, $homeBasis)}' on line 42, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${transformVectorsToBasis($integrationVectors, $homeBasis)}')) # from line 42, col 1.
        write(u'''
''')
        _v = VFFSL(SL,"copyVectors",False)(VFFSL(SL,"integrationVectors",True), '_oldCopy') # u"${copyVectors($integrationVectors, '_oldCopy')}" on line 44, col 1
        if _v is not None: write(_filter(_v, rawExpr=u"${copyVectors($integrationVectors, '_oldCopy')}")) # from line 44, col 1.
        write(u'''
''')
        for vector in VFFSL(SL,"integrationVectors",True): # generated from line 46, col 3
            write(u'''_active_''')
            _v = VFFSL(SL,"vector.id",True) # u'${vector.id}' on line 47, col 9
            if _v is not None: write(_filter(_v, rawExpr=u'${vector.id}')) # from line 47, col 9.
            write(u''' = _''')
            _v = VFFSL(SL,"vector.id",True) # u'${vector.id}' on line 47, col 25
            if _v is not None: write(_filter(_v, rawExpr=u'${vector.id}')) # from line 47, col 25.
            write(u''';
''')
        write(u'''
''')
        if VFFSL(SL,"cross",True): # generated from line 50, col 3
            write(u'''// Interpolate dependencies to the half-step
''')
            _v = VFFSL(SL,"interpolateDependencies",True) # u'${interpolateDependencies}' on line 52, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'${interpolateDependencies}')) # from line 52, col 1.
        write(u'''
for (int _iteration = 0; _iteration < ''')
        _v = VFFSL(SL,"iterations",True) # u'${iterations}' on line 55, col 39
        if _v is not None: write(_filter(_v, rawExpr=u'${iterations}')) # from line 55, col 39.
        write(u'''; _iteration++) {
  if (_iteration < ''')
        _v = VFFSL(SL,"iterations",True) # u'${iterations}' on line 56, col 20
        if _v is not None: write(_filter(_v, rawExpr=u'${iterations}')) # from line 56, col 20.
        write(u''' - 1) {
    ''')
        _v = VFFSL(SL,"callFunction",False)('deltaA', arguments, _step = '0.5*_step', parentFunction=function) # u"${callFunction('deltaA', arguments, _step = '0.5*_step', parentFunction=function), autoIndent=True}" on line 57, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u"${callFunction('deltaA', arguments, _step = '0.5*_step', parentFunction=function), autoIndent=True}")) # from line 57, col 5.
        write(u'''  } else {
    ''')
        _v = VFFSL(SL,"callFunction",False)('deltaA', arguments, parentFunction=function) # u"${callFunction('deltaA', arguments, parentFunction=function), autoIndent=True}" on line 59, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u"${callFunction('deltaA', arguments, parentFunction=function), autoIndent=True}")) # from line 59, col 5.
        write(u'''  }
  
  ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # u'${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}' on line 62, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u'${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}')) # from line 62, col 3.
        write(u'''  
  ''')
        _v = VFFSL(SL,"loopOverVectorsWithInnerContentTemplate",False)(VFFSL(SL,"integrationVectors",True),
"""// a = oldCopy + a
_${vector.id}[$index] += _oldCopy_${vector.id}[$index];
""", basis=VFFSL(SL,"homeBasis",True))
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u'${loopOverVectorsWithInnerContentTemplate($integrationVectors,\n"""// a = oldCopy + a\n_${vector.id}[$index] += _oldCopy_${vector.id}[$index];\n""", basis=$homeBasis), autoIndent=True}')) # from line 64, col 3.
        write(u'''}

''')
        _v = VFFSL(SL,"callFunction",False)('ipEvolve', arguments, _exponent = +1, parentFunction=function) # u"${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction=function)}" on line 70, col 1
        if _v is not None: write(_filter(_v, rawExpr=u"${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction=function)}")) # from line 70, col 1.
        write(u'''

''')
        _v = VFFSL(SL,"propagationDimension",True) # u'${propagationDimension}' on line 72, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${propagationDimension}')) # from line 72, col 1.
        write(u''' += 0.5*_step;

''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def interpolateDependencies(self, **KWS):



        ## CHEETAH: generated from @def interpolateDependencies at line 77, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        #  Insert code to interpolate the dependency vectors onto the half-step point.
        #  
        _v = VFFSL(SL,"reducedFieldCopy",False)(VFFSL(SL,"integrator.dependencyMap",True), 
"""
_active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}] = \\
    0.5*(_active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex}]
       + _active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex} + ${skipSize} * _${vector.id}_ncomponents]);
""")
        if _v is not None: write(_filter(_v, rawExpr=u'${reducedFieldCopy($integrator.dependencyMap, \n"""\n_active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}] = \\\\\n    0.5*(_active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex}]\n       + _active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex} + ${skipSize} * _${vector.id}_ncomponents]);\n""")}')) # from line 81, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        # SIStepper.tmpl
        # 
        # Created by Joe Hope on 2008-03-24.
        # 
        # Copyright (c) 2008-2012, Joe Hope and Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write(u'''

''')
        # 
        #   Single integration step (SI)
        write(u'''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    ipPropagationStepFractions = ['0.5']

    extraIntegrationArrayNames = ['oldCopy']

    isCrossCapable = True

    iterations = 3

    _mainCheetahMethod_for_SIStepper= 'writeBody'

## END CLASS DEFINITION

if not hasattr(SIStepper, '_initCheetahAttributes'):
    templateAPIClass = getattr(SIStepper, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(SIStepper)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=SIStepper()).run()


